<?php
/*
Plugin Name: Most active authors list
Plugin URI: http://www.designer-daily.com
Description: List the authors of the blog by number of articles.
Version: 1.0
Author: Mirko Humbert
Author URI: http://www.mirkohumbert.ch
*/
?>
<?php
error_reporting(E_ALL);


class Authors_list extends WP_Widget {

    function Authors_list(){
    $widget_ops = array('classname' => 'widget_authors_list', 'description' => __( "For multi-authors blogs, list the most active authors with the number of articles they have written") );
    $control_ops = array('width' => 250, 'height' => 250);
    $this->WP_Widget('authorslist', __('Most active authors list'), $widget_ops, $control_ops);
    }

  function widget($args, $instance){
    extract($args);
    $title = apply_filters('widget_title', empty($instance['title']) ? 'Most active authors' : $instance['title']);
    $nbrarticles = empty($instance['nbrarticles']) ? '10' : $instance['nbrarticles'];
    $allauthors = apply_filters('widget_title', empty($instance['allauthors']) ? '' : $instance['allauthors']);

    echo $before_widget;
      if ( $title ) echo $before_title . $title . $after_title;   
    
    
    echo '<ul class="listeauteurs">';
	$uc=array();
	$blogusers = get_users_of_blog();
		if ($blogusers) {
			foreach ($blogusers as $bloguser) {
				$post_count = get_usernumposts($bloguser->user_id);
				$uc[$bloguser->user_id]=$post_count;
				}
				arsort($uc);
				
				

				$count=0;
				foreach ($uc as $key => $value) {
					$count++;
						if ($count <= $nbrarticles) {
							$user = get_userdata($key);
							$author_posts_url = get_author_posts_url($key);
							$post_count = $value;
							if ($key != '6' && $post_count!='0') { ?>
							 
							<li>
								<a href="<?php bloginfo('url'); ?>/?author=<?php echo $user->ID; ?>">
									<?php
										echo $user->user_firstname;
										if ($user->user_firstname!='') {
											echo '&nbsp;';
										}
										echo $user->user_lastname; ?>
								</a> - <?php echo $post_count; if ($post_count==1) { echo '&nbsp;article'; } else { echo '&nbsp;articles'; } ?>
								
								<!-- <?php echo $user->user_url; ?> -->
								 <a href="<?php bloginfo('url'); ?>/author/<?php echo $user->display_name; ?>/feed/">
								 
								<?php echo '<img src="' .plugins_url( 'authorslist/feed-icon.png' , dirname(__FILE__) ). '" style="vertical-align:middle;margin-left:5px;margin-bottom:3px;" > '; ?>
								
							</li>
							<?php } } } }; ?>
						<?php if ( $allauthors ) echo '<li><a href="' . $allauthors . '"><strong>All authors</strong></a></li>'; ?>	
						</ul>
   
    
    <?php
    echo $args['after_widget'];
  }


 function update($new_instance, $old_instance){
      $instance = $old_instance;
      $instance['title'] = strip_tags(stripslashes($new_instance['title']));
      $instance['nbrarticles'] = strip_tags(stripslashes($new_instance['nbrarticles']));
      $instance['allauthors'] = strip_tags(stripslashes($new_instance['allauthors']));
    return $instance;
  }
  
  function form($instance){
      //Defaults
      $instance = wp_parse_args( (array) $instance, array('title'=>'Most active authors', 'nbrarticles'=>'10', 'allauthors'=>''));
      $title = htmlspecialchars($instance['title']);
	  $nbrarticles = htmlspecialchars($instance['nbrarticles']);
	  $allauthors = htmlspecialchars($instance['allauthors']);
     

      # Output the options
      ?>
      <p style="text-align:left;"><label for="<?php echo $this->get_field_name('title'); ?>"><?php echo __('Title:'); ?><input style="width: 200px;" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
      <p style="text-align:left;"><label for="<?php echo $this->get_field_name('nbrarticles'); ?>"><?php echo __('Number of authors to display:'); ?><input style="width: 25px;" id="<?php echo $this->get_field_id('nbrarticles'); ?>" name="<?php echo $this->get_field_name('nbrarticles'); ?>" type="text" value="<?php echo $nbrarticles; ?>" /></label></p>
      <p style="text-align:left;"><label for="<?php echo $this->get_field_name('allauthors'); ?>"><?php echo __('Full URL of the page with all authors, leave empty if you you have no author page'); ?><input style="width: 200px;" id="<?php echo $this->get_field_id('allauthors'); ?>" name="<?php echo $this->get_field_name('allauthors'); ?>" type="text" value="<?php echo $allauthors; ?>" /></label></p>
      <?php
  }

}
  /* Registering the widget */
  function Authors_listInit() {
  register_widget('Authors_list');
  }
  add_action('widgets_init', 'Authors_listInit');
?>